#!/bin/bash
#This script is part of pinlabeler, by Peter Storm.
#It reads standard input (usually gvpin),
#and sends it to the pinlabel output window OUTPUT_WINDOW,
#e.g. gvim.  It is sent using xse.
#The environment variables OUTPUT_WINDOW and XSE
#used here are defined in pin.sh.
#vim syntax may parse this file incorrectly.

#written originally in February, 2009
#last modified April, 2009

tmpfile="/tmp/pinlabeler.$$"
\rm -f "$tmpfile"
touch "$tmpfile"

trap '\rm -f $tmpfile' 1 2 15

while read line; do #reads one line output gvpin output
    if [ "${line%% *}" != "\\pinlabel" ]
    then
	echo "warning, unexpected output from gvpin: ${line}" >&2
	continue
    fi
    n=0
    #next loop parses characters and sends them to tmpfile
    while [ "$n" -lt "${#line}" ] 
    do
	char="${line:n:1}"
	n=$(( $n + 1 ))
	case "$char" in
	    '\')
		output='<KeyPress> backslash';;
	    ' ')
		output='<KeyPress> space';;
	    ']')
		output='<KeyPress> bracketright';;
	    '[')
		output='<KeyPress> bracketleft';;
	    '$')
		output='Shift<Key>4';;
	    '{')
		output='Shift<Key>bracketleft';;
	    '}')
		output='Shift<Key>bracketright';;
	    *)
		output="<KeyPress> $char";;
	esac	
	echo "$output" >> "$tmpfile"
    done
    echo "<KeyPress> Return" >> "$tmpfile"
    #send contents of tmpfile to xse
    "$XSE" -window "$OUTPUT_WINDOW" -file "$tmpfile"
    \rm -f "$tmpfile"
    touch "$tmpfile"
done

\rm -f "$tmpfile"
